package ecp.vcs.com.ecpsyncplugin.addons.addons_plugin

import android.annotation.SuppressLint
import android.content.Context
import android.provider.Settings
import android.util.Base64
import android.util.Log
import javax.crypto.Cipher
import javax.crypto.spec.IvParameterSpec
import javax.crypto.spec.SecretKeySpec

class encriptionDetails {

    @Throws(Exception::class)
    fun Decrypt(text: String, key: String): String? {
        val cipher =
            Cipher.getInstance("AES/CBC/PKCS5Padding") //this parameters should not be changed
        val keyBytes = ByteArray(16)
        val b = key.toByteArray(charset("UTF-8"))
        var len = b.size
        if (len > keyBytes.size) len = keyBytes.size
        System.arraycopy(b, 0, keyBytes, 0, len)
        val keySpec = SecretKeySpec(keyBytes, "AES")
        val ivSpec = IvParameterSpec(keyBytes)
        cipher.init(Cipher.DECRYPT_MODE, keySpec, ivSpec)
        var results: ByteArray? = ByteArray(text.length)
        //BASE64Decoder decoder = new BASE64Decoder();
        try {
            results = cipher.doFinal(decodeString(text))
        } catch (e: Exception) {
            println("Error in Decryption : $e")
        }
        println("Data : " + String(results!!, Charsets.UTF_8))
        return String(results, Charsets.UTF_8) // it returns the result as a String
    }

    // Encription Methods
    @Throws(Exception::class)
    fun Encrypt(text: String, key: String): String? {
        val cipher = Cipher.getInstance("AES/CBC/PKCS5Padding")
        val keyBytes = ByteArray(16)
        val b = key.toByteArray(charset("UTF-8"))
        var len = b.size
        if (len > keyBytes.size) len = keyBytes.size
        System.arraycopy(b, 0, keyBytes, 0, len)
        val keySpec = SecretKeySpec(keyBytes, "AES")
        val ivSpec = IvParameterSpec(keyBytes)
        cipher.init(Cipher.ENCRYPT_MODE, keySpec, ivSpec)
        val results = cipher.doFinal(text.toByteArray(charset("UTF-8")))
        //BASE64Encoder encoder = new BASE64Encoder();
        return encodeString(results) // it returns the result as a String
    }

    private fun encodeString(results: ByteArray): String? {
        return Base64.encodeToString(results, Base64.DEFAULT).trim { it <= ' ' }
    }

    private fun decodeString(results: String): ByteArray? {
        var data: ByteArray? = null
        try {
            data = Base64.decode(results.toByteArray(charset("UTF-8")), Base64.DEFAULT)
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return data
    }

    //private static String Key = "your key";

    /*public static String encryptString(String stringToEncode, String Key, String iv1) throws NullPointerException {

        try {
            SecretKeySpec skeySpec = getKey(Key);
            byte[] clearText = stringToEncode.getBytes("UTF8");
            //final byte[] iv = new byte[16];
            final byte[] iv = iv1.getBytes();
            Arrays.fill(iv, (byte) 0x00);
            IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS7Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skeySpec, ivParameterSpec);
            return Base64.encodeToString(cipher.doFinal(clearText), Base64.DEFAULT);

        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    public static String decryptString(String stringToEncode, String Key, String iv1) throws NullPointerException {

        try {
            SecretKeySpec skeySpec = getKey(Key);
            byte[] clearText = stringToEncode.getBytes("UTF8");
            final byte[] iv = iv1.getBytes();
            Arrays.fill(iv, (byte) 0x00);
            IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS7Padding");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, ivParameterSpec);
            byte[] cipherData = cipher.doFinal(Base64.decode(clearText, Base64.DEFAULT));
            return new String(cipherData, "UTF-8");

        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }


    private static SecretKeySpec getKey(String password) throws UnsupportedEncodingException {
        int keyLength = 256;
        byte[] keyBytes = new byte[keyLength / 8];
        Arrays.fill(keyBytes, (byte) 0x0);
        byte[] passwordBytes = password.getBytes("UTF-8");
        int length = passwordBytes.length < keyBytes.length ? passwordBytes.length : keyBytes.length;
        System.arraycopy(passwordBytes, 0, keyBytes, 0, length);
        SecretKeySpec key = new SecretKeySpec(keyBytes, "AES");
        return key;
    }*/


    fun getUniqueNumber(context: Context): String? {
        val androidids = getUniqueID(context)
        val randomNumber = getRandomNumber()
        Log.e("LENGTH",
            androidids.length.toString() + " : " + System.currentTimeMillis()
                .toString().length + " : " + randomNumber.length
        )
        return androidids + System.currentTimeMillis() + getRandomNumber()
    }

    @SuppressLint("HardwareIds")
    private fun getUniqueID(context: Context): String {
        return Settings.Secure.getString(context.contentResolver, Settings.Secure.ANDROID_ID)
    }

    private fun getRandomNumber(): String {
        val number = Math.floor(Math.random() * 6000000L).toLong() + 1000000L
        return number.toString()
    }
}